# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xmaintenancewindow`](#dsc_xmaintenancewindow): The DSC xMaintenanceWindow resource type. Automatically generated from version 1.0.41.1
* [`dsc_xwaitforitem`](#dsc_xwaitforitem): The DSC xWaitForItem resource type. Automatically generated from version 1.0.41.1

## Resource types

### <a name="dsc_xmaintenancewindow"></a>`dsc_xmaintenancewindow`

The DSC xMaintenanceWindow resource type.
Automatically generated from version 1.0.41.1

#### Properties

The following properties are available in the `dsc_xmaintenancewindow` type.

##### `dsc_currenttime`

Data type: `Optional[Timestamp]`

Current system time

##### `dsc_dayofmonth`

Data type: `Optional[Integer[-32768, 32767]]`

The nth day of a month. In conjunction with DayOfWeek uses e.g. the nth Monday of the month

##### `dsc_dayofweek`

Data type: `Optional[Enum['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday']]`

The day the maintenance window is defined for. ScheduleEnd can exceed the DayOfWeek

##### `dsc_scheduletype`

Data type: `Optional[Array[Enum['Once', 'Daily', 'Weekly', 'Monthly']]]`

The desired schedule. If the default Once is used, the exact date will be checked. If Daily is specified, DayOfWeek, DayOfMonth and DayNameOfMonth are ignored. If Weekly is specified, DayOfMonth is ignored. If Monthly is specified, DayOfWeek can be used to express nth Monday of the month

##### `dsc_scriptblock`

Data type: `Optional[String]`

The script block to generate a schedule from an external system, e.g. a CMDB, a file, the moon phase, ... Needs to return a hash table with the keys ScheduleStart and ScheduleEnd. Can optionally contain all parameters of the DSC resource except ScriptBlock to further control resource processing. If ScriptBlock is used, all parameters are ignored.

#### Parameters

The following parameters are available in the `dsc_xmaintenancewindow` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_scheduleend`](#dsc_scheduleend)
* [`dsc_schedulestart`](#dsc_schedulestart)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_scheduleend"></a>`dsc_scheduleend`

namevar

Data type: `Timestamp`

The end of the schedule. The property TimeOfDay is used for setting the schedule

##### <a name="dsc_schedulestart"></a>`dsc_schedulestart`

namevar

Data type: `Timestamp`

The start of the schedule. The property TimeOfDay is used for setting the schedule

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwaitforitem"></a>`dsc_xwaitforitem`

The DSC xWaitForItem resource type.
Automatically generated from version 1.0.41.1

#### Properties

The following properties are available in the `dsc_xwaitforitem` type.

##### `dsc_childitemcount`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The exact child item count including all files and folders

##### `dsc_ensure`

Data type: `Optional[Enum['Absent', 'Present']]`

Ensure

##### `dsc_length`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The exact file length as implemented by System.IO.FileInfo

##### `dsc_minimumchilditemcount`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The minimum child item count including all files and folders

##### `dsc_minimumlength`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The minimum file length as implemented by System.IO.FileInfo

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

Retry count

##### `dsc_retryinterval`

Data type: `Optional[Integer[0, 4294967295]]`

Retry interval in seconds

##### `dsc_type`

Data type: `Enum['Directory', 'File']`

The type of the target item

#### Parameters

The following parameters are available in the `dsc_xwaitforitem` type.

* [`dsc_path`](#dsc_path)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_path"></a>`dsc_path`

namevar

Data type: `String`

The path to the file or folder

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

